#!/usr/bin/perl

use strict;
use File::Copy;

my $fonmon_conf = "/etc/asterisk/FONmon.conf";

# make backup copy first
File::Copy::copy($fonmon_conf, $fonmon_conf.".bak_ip");

# add checkiptables
open(FH, '<', $fonmon_conf.".bak_ip");
open(FF, '>', $fonmon_conf);

my $found_iptables = 0;
while(my $line = <FH>)
{
	if($line =~ /checkiptables\s*=\s*(\d+)/)
	{
		$found_iptables = 1;
	}
	print FF $line;
}

if(!$found_iptables)
{
	print FF "\ncheckiptables = 0";
	print FF "\ncheckiptables_interval = 300";
}

close(FH);
close(FF);

unlink($fonmon_conf.".bak_ip");

# restart FONmon
system('/var/www/rpc/surun /etc/init.d/FONmon restart');
