#!/usr/bin/perl

use strict;
use File::Copy;

my $httpd_conf = "/usr/local/apache/conf/httpd.conf";

# make backup copy first
File::Copy::copy($httpd_conf, $httpd_conf.".bak_cgi");

# add location cgi-bin
open(FH, '<', $httpd_conf.".bak_cgi");
open(FF, '>', $httpd_conf);

my $found_location_cgi = 0;
while(my $line = <FH>)
{
	$line =~ s/ScriptAlias \/cgi-bin\/ "\/usr\/local\/apache\/cgi-bin"/ScriptAlias \/cgi-bin\/ "\/usr\/local\/apache\/cgi-bin\/"/g;
	if($line =~ /\<Location \/cgi-bin\>/)
	{
		$found_location_cgi = 1;
	}
	print FF $line;
}

if(!$found_location_cgi)
{
	print FF "\n<Location /cgi-bin>\n";
	print FF "  AuthUserFile /etc/htpasswd\n";
	print FF "  AuthType Basic\n";
	print FF "  AuthName SecuredRPC\n";
	print FF "  require valid-user\n";
	print FF "</Location>\n\n";
}

close(FH);
close(FF);

# restart apache
system('/usr/local/apache/bin/apachectl restart');
