#!/usr/bin/perl

open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: logs.pl(@ARGV)\n"; close(LOG);
use DBI;
use strict;

# make sure we're not already running
(my $proc = $0) =~ s|^.*?([^/]+)$|$1|;
chomp(my $procs = `ps auwx|grep $proc|grep -cv grep`);   
if ($procs > 1)
{
        die "$proc already running! not running.\n";
}

exit unless -e "/var/log/asterisk/cdr-csv/Master.csv";

open(CONF, "</etc/asterisk/fonality/globals.conf") || error("Can't open file: $!");
my $account;
my $areacode;
while (<CONF>)
{
	$areacode = $1 if /^LOCAL_AREA_CODE\s*=\s*(\d+)/;
	$account = $1 if /^ACCOUNT\s*=\s*(\d+)/;
}
close(CONF);

error("No account found") unless $account;

my $dbh = DBI->connect("DBI:mysql:host=192.168.178.1;database=pbxtra", "insert", "insert") || error("Can't connect to db");
my $sth = $dbh->prepare("
	INSERT INTO cdr
	(accountcode,src,dst,dcontext,clid,channel,dstchannel,lastapp,lastdata,
	calldate,callend,duration,billsec,disposition,amaflags)
	VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)
");

my $time = time;
rename("/var/log/asterisk/cdr-csv/Master.csv", "/var/log/asterisk/cdr-csv/Master.csv.$time") || error("Can't rename csv: $!");

open(CDR, "</var/log/asterisk/cdr-csv/Master.csv.$time") || error("Can't open csv: $!");
while (<CDR>)
{
	chomp;
	s/^".*?"/$account"/;
	s/,(\d*)(?=,)/,"$1"/g;
	s/"$//g;
	my @fields = split /","/;

	# set the local area code if needed
	$fields[2] =~ s/^9(\d{7})$/91$areacode$1/;
	$fields[2] =~ s/^9(\d{10})$/91$1/;

	splice(@fields, 10, 1);
	$sth->execute(@fields);
}
close(CDR);
exit;

sub error
{
	my $error = shift;
	die $error;
}
