<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Sat Sep  4 08:46:54 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>server_stats</name>
<version>1.0</version>
<signature>array array</signature>
<help>
Return hash ref of server stats form rrd tables
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
###############################################################################
#
#   Sub Name:       server_stats
#
#   Description:    current server stats (cpu, mem).
#
#   Arguments:      NAME      IN/OUT  TYPE      DESCRIPTION
#                   $srv      in      ref       Server object instance
#
#   Globals:        None.
#
#   Environment:    None.
#
#   Returns:        Array of Server stats.
#
###############################################################################
sub server_stats
{
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: server_stats.xpl(@_)\n"; close(LOG);
        my ($srv, $data) = @_;
	
	my ($howlong, $type) = @{$data};

	#my ($start, $end) = @{$data};
	my $time = time();

	my $start = $time - 1;
	if ($howlong eq "live")
	{
		$start -= 60;
	}
	elsif($howlong eq "hour")
	{
		$start -= (1 * 60 * 60);	
	}
	elsif($howlong =~ /^(\d+)min$/)
	{
		$start -= ($1 * 60);	
	}
	elsif($howlong eq "sixhour")
	{
		$start -= (6 * 60 * 60);	
	}
	elsif ($howlong eq "daily")
	{
		$start -= (24 * 60 * 60);
	}
	elsif ($howlong eq "weekly")
	{
		$start -= (7 * 24 * 60 * 60);
	}
	elsif ($howlong eq "monthly")
	{
		$start -= (30 * 24 * 60 * 60);
	}

	my $end = $time - 2;

	use strict;
	use lib qw( /usr/local/rrdtool-1.2.13/lib/perl );
	use lib qw( /usr/local/rrdtool-1.2.15/lib/perl );
	use RRDs;

	#
	# types:
	#   0 = server_stats
	#   1 = call_stats
	#   2 = network
	#
	my @DB = qw|
		/var/lib/asterisk/server_stats.rrd
		/var/lib/asterisk/call_stats.rrd
		/var/lib/asterisk/network_stats.rrd
	|;
	my $dst = "AVERAGE";

	my ($dbstart, $step, $names, $data) = RRDs::fetch($DB[$type], "--start=$start", "--end=$end", $dst);

	if ($howlong eq "hour" || $howlong =~ /^(\d+)min$/)
	{
		for (my $i = $#$data+1; $i >= 0; $i--)
		{
			# $1 || 60 (defined minutes or hour)
			# that many minutes over 15, for example, 60 / 15 = 4
			# 10 * that num == 40, so only show 1 point for every 40
			if ($i % int(10 * (($1 || 60) / 15)))
			{
				splice(@{$data}, $i, 1);
			}
		}
	}

	return [$data, $start, $end];
}

__END__
]]></code>
</methoddef>
