<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Sat Jan 22 01:00:47 2005

    Any changes made here will be lost.
-->
<methoddef>
<name>set_localtime</name>
<version>1.1</version>
<signature>array array</signature>
<help>
Replaces /etc/localtime with the time file provide (full path required).
Will error if time file path does not begin with /usr/share/zoneinfo/
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
##############################################################################
# set_localtime: locally copies the time zone file provided to /etc/localtime
#                to update the servers localtime.
#
#    Args: file path
# Returns: 1 on success or die "why" on error 
##############################################################################
sub set_localtime
{
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: set_localtime.xpl(@_)\n"; close(LOG);
	my $sob       = shift ;  # Apache::RPC::Server object is always passed
	my $file_aref = shift ;  # file is passed in an arrayref so deref for the first val

	my $file = $file_aref->[0] ;

	my $mosted = $file_aref->[1];
	my $prefix;	
	if ( $mosted )
	{
		$prefix = "/data/$mosted";
	}
	use File::Copy ;

	#
    #  Verify that the person is trying to copy a time zone file
    #
    if ( $file !~ /^\/usr\/share\/zoneinfo/ ) {
        die "Unable to copy local time file '$file' to '$prefix/etc/localtime'. Reason: " . 
            "file '$file' is not recognized as a time zone file." ;
    }
    #
    #  Get the file data from the new timezone file
    #
    if ( File::Copy::copy($file, "$prefix/etc/localtime") ) {
       	return 1; 
    } else {                                                                                                      
        die "Unable copy local time file '$file' to '$prefix/etc/localtime'. Reason: unable to read file '$file'" ;      
    }                                                                                                             
}    


__END__
]]></code>
</methoddef>
